package jalview.datamodel.features;

import static org.testng.Assert.assertEquals;
import static org.testng.Assert.assertTrue;

import java.util.Comparator;

import junit.extensions.PA;

import org.testng.annotations.Test;

public class FeatureAttributesTest
{

  /**
   * Test the method that keeps attribute names in non-case-sensitive order,
   * including handling of 'compound' names
   */
  @Test(groups="Functional")
  public void testAttributeNameComparator()
  {
    FeatureAttributes fa = FeatureAttributes.getInstance();
    Comparator<String[]> comp = (Comparator<String[]>) PA.getValue(fa,
            "comparator");

    assertEquals(
            comp.compare(new String[] { "CSQ" }, new String[] { "csq" }), 0);

    assertTrue(comp.compare(new String[] { "CSQ", "a" },
            new String[] { "csq" }) > 0);

    assertTrue(comp.compare(new String[] { "CSQ" }, new String[] { "csq",
        "b" }) < 0);

    assertTrue(comp.compare(new String[] { "CSQ", "AF" }, new String[] {
        "csq", "ac" }) > 0);

    assertTrue(comp.compare(new String[] { "CSQ", "ac" }, new String[] {
        "csq", "AF" }) < 0);
  }
}
